(** File generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_alpha.Environment.
Require TezosOfOCaml.Proto_alpha.Path_encoding.
Require TezosOfOCaml.Proto_alpha.Raw_level_repr.
Require TezosOfOCaml.Proto_alpha.Storage_description.
Require TezosOfOCaml.Proto_alpha.Storage_sigs.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_inbox_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_level_repr.

Module Commitment_hash.
  Definition commitment_hash : string := "\017\249\195\r".
  
  Definition H :=
    Blake2B.Make
      {|
        Blake2B.Register.register_encoding _ := Base58.register_encoding
      |}
      (let name := "Commitment_hash" in
      let title := "A commitment ID" in
      let b58check_prefix := commitment_hash in
      let size_value := Some 32 in
      {|
        Blake2B.PrefixedName.name := name;
        Blake2B.PrefixedName.title := title;
        Blake2B.PrefixedName.size_value := size_value;
        Blake2B.PrefixedName.b58check_prefix := b58check_prefix
      |}).
  
  (** Inclusion of the module [H] *)
  Definition t := H.(S.HASH.t).
  
  Definition name := H.(S.HASH.name).
  
  Definition title := H.(S.HASH.title).
  
  Definition pp := H.(S.HASH.pp).
  
  Definition pp_short := H.(S.HASH.pp_short).
  
  Definition op_eq := H.(S.HASH.op_eq).
  
  Definition op_ltgt := H.(S.HASH.op_ltgt).
  
  Definition op_lt := H.(S.HASH.op_lt).
  
  Definition op_lteq := H.(S.HASH.op_lteq).
  
  Definition op_gteq := H.(S.HASH.op_gteq).
  
  Definition op_gt := H.(S.HASH.op_gt).
  
  Definition compare := H.(S.HASH.compare).
  
  Definition equal := H.(S.HASH.equal).
  
  Definition max := H.(S.HASH.max).
  
  Definition min := H.(S.HASH.min).
  
  Definition hash_bytes := H.(S.HASH.hash_bytes).
  
  Definition hash_string := H.(S.HASH.hash_string).
  
  Definition zero := H.(S.HASH.zero).
  
  Definition size_value := H.(S.HASH.size_value).
  
  Definition to_bytes := H.(S.HASH.to_bytes).
  
  Definition of_bytes_opt := H.(S.HASH.of_bytes_opt).
  
  Definition of_bytes_exn := H.(S.HASH.of_bytes_exn).
  
  Definition to_b58check := H.(S.HASH.to_b58check).
  
  Definition to_short_b58check := H.(S.HASH.to_short_b58check).
  
  Definition of_b58check_exn := H.(S.HASH.of_b58check_exn).
  
  Definition of_b58check_opt := H.(S.HASH.of_b58check_opt).
  
  Definition b58check_encoding := H.(S.HASH.b58check_encoding).
  
  Definition encoding := H.(S.HASH.encoding).
  
  (* Definition rpc_arg := H.(S.HASH.rpc_arg). *)
  
  (** Init function; without side-effects in Coq *)
  Definition init_module_repr : unit :=
    Base58.check_encoded_prefix b58check_encoding "toc1" 54.
  
  Definition Path_encoding_Make_hex_include :=
    Path_encoding.Make_hex
      {|
        Path_encoding.ENCODING.to_bytes := H.(S.HASH.to_bytes);
        Path_encoding.ENCODING.of_bytes_opt := H.(S.HASH.of_bytes_opt)
      |}.
  
  (** Inclusion of the module [Path_encoding_Make_hex_include] *)
  Definition to_path :=
    Path_encoding_Make_hex_include.(Path_encoding.S.to_path).
  
  Definition of_path :=
    Path_encoding_Make_hex_include.(Path_encoding.S.of_path).
  
  Definition path_length :=
    Path_encoding_Make_hex_include.(Path_encoding.S.path_length).
  
  Definition rpc_arg : RPC_arg.arg t :=
    let construct := Data_encoding.Binary.to_string_exn None encoding in
    let destruct (str : string) : Pervasives.result t string :=
      (fun x_1 => Option.value_e x_1 "Failed to decode commitment")
        (Data_encoding.Binary.of_string_opt encoding str) in
    RPC_arg.make (Some "A tx_rollup commitment.") "tx_rollup_commitment"
      destruct construct tt.
End Commitment_hash.

Module batch_commitment.
  Record record : Set := Build {
    root : bytes }.
  Definition with_root root (r : record) :=
    Build root.
End batch_commitment.
Definition batch_commitment := batch_commitment.record.

Module Batch.
  Definition t : Set := batch_commitment.
  
  Definition encoding : Data_encoding.encoding batch_commitment :=
    Data_encoding.conv
      (fun (function_parameter : batch_commitment) =>
        let '{| batch_commitment.root := root |} := function_parameter in
        root) (fun (root : bytes) => {| batch_commitment.root := root |}) None
      (Data_encoding.obj1
        (Data_encoding.req None None "root" Data_encoding.bytes_value)).
  
  Definition pp (fmt : Format.formatter) (function_parameter : t) : unit :=
    let '{| batch_commitment.root := root |} := function_parameter in
    Hex.pp fmt (Hex.of_bytes None root).
  
  Definition Compare_Make_include :=
    Compare.Make
      (let t : Set := t in
      let compare (function_parameter : batch_commitment)
        : batch_commitment -> int :=
        let '{| batch_commitment.root := root1 |} := function_parameter in
        fun (function_parameter : batch_commitment) =>
          let '{| batch_commitment.root := root2 |} := function_parameter in
          Bytes.compare root1 root2 in
      {|
        Compare.COMPARABLE.compare := compare
      |}).
  
  (** Inclusion of the module [Compare_Make_include] *)
  Definition op_eq := Compare_Make_include.(Compare.S.op_eq).
  
  Definition op_ltgt := Compare_Make_include.(Compare.S.op_ltgt).
  
  Definition op_lt := Compare_Make_include.(Compare.S.op_lt).
  
  Definition op_lteq := Compare_Make_include.(Compare.S.op_lteq).
  
  Definition op_gteq := Compare_Make_include.(Compare.S.op_gteq).
  
  Definition op_gt := Compare_Make_include.(Compare.S.op_gt).
  
  Definition compare := Compare_Make_include.(Compare.S.compare).
  
  Definition equal := Compare_Make_include.(Compare.S.equal).
  
  Definition max := Compare_Make_include.(Compare.S.max).
  
  Definition min := Compare_Make_include.(Compare.S.min).
End Batch.

Definition batch_commitment_equal
  : batch_commitment -> batch_commitment -> bool := Batch.equal.

Module t.
  Record record : Set := Build {
    level : Tx_rollup_level_repr.t;
    batches : list batch_commitment;
    predecessor : option Commitment_hash.t;
    inbox_hash : Tx_rollup_inbox_repr.hash }.
  Definition with_level level (r : record) :=
    Build level r.(batches) r.(predecessor) r.(inbox_hash).
  Definition with_batches batches (r : record) :=
    Build r.(level) batches r.(predecessor) r.(inbox_hash).
  Definition with_predecessor predecessor (r : record) :=
    Build r.(level) r.(batches) predecessor r.(inbox_hash).
  Definition with_inbox_hash inbox_hash (r : record) :=
    Build r.(level) r.(batches) r.(predecessor) inbox_hash.
End t.
Definition t := t.record.

Definition compare_or {A B : Set}
  (cmp : A -> B -> int) (c1 : A) (c2 : B) (f_value : unit -> int) : int :=
  match cmp c1 c2 with
  | 0 => f_value tt
  | diff_value => diff_value
  end.

Definition Compare_Make_include :=
  Compare.Make
    (let t : Set := t in
    let Compare_root_list :=
      Compare.List
        {|
          Compare.COMPARABLE.compare := Batch.compare
        |} in
    let compare (r1 : t) (r2 : t) : int :=
      compare_or Tx_rollup_level_repr.compare r1.(t.level) r2.(t.level)
        (fun (function_parameter : unit) =>
          let '_ := function_parameter in
          compare_or Compare_root_list.(Compare.S.compare) r1.(t.batches)
            r2.(t.batches)
            (fun (function_parameter : unit) =>
              let '_ := function_parameter in
              compare_or (Option.compare Commitment_hash.compare)
                r1.(t.predecessor) r2.(t.predecessor)
                (fun (function_parameter : unit) =>
                  let '_ := function_parameter in
                  Tx_rollup_inbox_repr.compare_hash r1.(t.inbox_hash)
                    r2.(t.inbox_hash)))) in
    {|
      Compare.COMPARABLE.compare := compare
    |}).

(** Inclusion of the module [Compare_Make_include] *)
Definition op_eq := Compare_Make_include.(Compare.S.op_eq).

Definition op_ltgt := Compare_Make_include.(Compare.S.op_ltgt).

Definition op_lt := Compare_Make_include.(Compare.S.op_lt).

Definition op_lteq := Compare_Make_include.(Compare.S.op_lteq).

Definition op_gteq := Compare_Make_include.(Compare.S.op_gteq).

Definition op_gt := Compare_Make_include.(Compare.S.op_gt).

Definition compare := Compare_Make_include.(Compare.S.compare).

Definition equal := Compare_Make_include.(Compare.S.equal).

Definition max := Compare_Make_include.(Compare.S.max).

Definition min := Compare_Make_include.(Compare.S.min).

Definition pp (fmt : Format.formatter) (t_value : t) : unit :=
  Format.fprintf fmt
    (CamlinternalFormatBasics.Format
      (CamlinternalFormatBasics.String_literal "commitment "
        (CamlinternalFormatBasics.Alpha
          (CamlinternalFormatBasics.String_literal " : batches = "
            (CamlinternalFormatBasics.Alpha
              (CamlinternalFormatBasics.String_literal " predecessor "
                (CamlinternalFormatBasics.Alpha
                  (CamlinternalFormatBasics.String_literal " for inbox "
                    (CamlinternalFormatBasics.Alpha
                      CamlinternalFormatBasics.End_of_format))))))))
      "commitment %a : batches = %a predecessor %a for inbox %a")
    Tx_rollup_level_repr.pp t_value.(t.level)
    (Format.pp_print_list None Batch.pp) t_value.(t.batches)
    (Format.pp_print_option None Commitment_hash.pp) t_value.(t.predecessor)
    Tx_rollup_inbox_repr.pp_hash t_value.(t.inbox_hash).

Definition encoding : Data_encoding.encoding t :=
  Data_encoding.conv
    (fun (function_parameter : t) =>
      let '{|
        t.level := level;
          t.batches := batches;
          t.predecessor := predecessor;
          t.inbox_hash := inbox_hash
          |} := function_parameter in
      (level, batches, predecessor, inbox_hash))
    (fun (function_parameter :
      Tx_rollup_level_repr.t * list batch_commitment * option Commitment_hash.t
        * Tx_rollup_inbox_repr.hash) =>
      let '(level, batches, predecessor, inbox_hash) := function_parameter in
      {| t.level := level; t.batches := batches; t.predecessor := predecessor;
        t.inbox_hash := inbox_hash |}) None
    (Data_encoding.obj4
      (Data_encoding.req None None "level" Tx_rollup_level_repr.encoding)
      (Data_encoding.req None None "batches"
        (Data_encoding.list_value None Batch.encoding))
      (Data_encoding.req None None "predecessor"
        (Data_encoding.option_value Commitment_hash.encoding))
      (Data_encoding.req None None "inbox_hash"
        Tx_rollup_inbox_repr.hash_encoding)).

Definition hash_value (c_value : t) : Commitment_hash.t :=
  let bytes_value := Data_encoding.Binary.to_bytes_exn None encoding c_value in
  Commitment_hash.hash_bytes None [ bytes_value ].

Module Index.
  Definition t : Set := Commitment_hash.t.
  
  Definition path_length : int := 1.
  
  Definition to_path (c_value : Commitment_hash.t) (l_value : list string)
    : list string :=
    let raw_key :=
      Data_encoding.Binary.to_bytes_exn None Commitment_hash.encoding c_value in
    let 'Hex.Hex key_value := Hex.of_bytes None raw_key in
    cons key_value l_value.
  
  Definition of_path (function_parameter : list string)
    : option Commitment_hash.t :=
    match function_parameter with
    | cons key_value [] =>
      Option.bind (Hex.to_bytes (Hex.Hex key_value))
        (Data_encoding.Binary.of_bytes_opt Commitment_hash.encoding)
    | _ => None
    end.
  
  Definition rpc_arg : RPC_arg.arg Commitment_hash.t := Commitment_hash.rpc_arg.
  
  Definition encoding : Data_encoding.t Commitment_hash.t :=
    Commitment_hash.encoding.
  
  Definition compare : Commitment_hash.t -> Commitment_hash.t -> int :=
    Commitment_hash.compare.
  
  Definition module :=
    {|
      Storage_description.INDEX.path_length := path_length;
      Storage_description.INDEX.to_path := to_path;
      Storage_description.INDEX.of_path := of_path;
      Storage_description.INDEX.rpc_arg := rpc_arg;
      Storage_description.INDEX.encoding := encoding;
      Storage_description.INDEX.compare := compare
    |}.
End Index.
Definition Index := Index.module.

Module Submitted_commitment.
  Module t.
    Record record : Set := Build {
      commitment : t;
      commitment_hash : Commitment_hash.t;
      committer : Signature.public_key_hash;
      submitted_at : Raw_level_repr.t;
      finalized_at : option Raw_level_repr.t }.
    Definition with_commitment commitment (r : record) :=
      Build commitment r.(commitment_hash) r.(committer) r.(submitted_at)
        r.(finalized_at).
    Definition with_commitment_hash commitment_hash (r : record) :=
      Build r.(commitment) commitment_hash r.(committer) r.(submitted_at)
        r.(finalized_at).
    Definition with_committer committer (r : record) :=
      Build r.(commitment) r.(commitment_hash) committer r.(submitted_at)
        r.(finalized_at).
    Definition with_submitted_at submitted_at (r : record) :=
      Build r.(commitment) r.(commitment_hash) r.(committer) submitted_at
        r.(finalized_at).
    Definition with_finalized_at finalized_at (r : record) :=
      Build r.(commitment) r.(commitment_hash) r.(committer) r.(submitted_at)
        finalized_at.
  End t.
  Definition t := t.record.
  
  Definition encoding : Data_encoding.encoding t :=
    Data_encoding.conv
      (fun (function_parameter : t) =>
        let '{|
          t.commitment := commitment;
            t.commitment_hash := commitment_hash;
            t.committer := committer;
            t.submitted_at := submitted_at;
            t.finalized_at := finalized_at
            |} := function_parameter in
        (commitment, commitment_hash, committer, submitted_at, finalized_at))
      (fun (function_parameter :
        _ * Commitment_hash.t * Signature.public_key_hash * Raw_level_repr.t *
          option Raw_level_repr.t) =>
        let
          '(commitment, commitment_hash, committer, submitted_at, finalized_at) :=
          function_parameter in
        {| t.commitment := commitment; t.commitment_hash := commitment_hash;
          t.committer := committer; t.submitted_at := submitted_at;
          t.finalized_at := finalized_at |}) None
      (Data_encoding.obj5 (Data_encoding.req None None "commitment" encoding)
        (Data_encoding.req None None "commitment_hash" Commitment_hash.encoding)
        (Data_encoding.req None None "committer"
          Signature.Public_key_hash.(S.SIGNATURE_PUBLIC_KEY_HASH.encoding))
        (Data_encoding.req None None "submitted_at" Raw_level_repr.encoding)
        (Data_encoding.opt None None "finalized_at" Raw_level_repr.encoding)).
  
  Definition module :=
    {|
      Storage_sigs.VALUE.encoding := encoding
    |}.
End Submitted_commitment.
Definition Submitted_commitment := Submitted_commitment.module.
